//////////////////////////////
// gdx_indi.c
// written by Michael Gibson
// released under the GPl
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

 char indi_check[55];
 char filename[55];


 char indi_sex[7];
 int  indi_sex_t;

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}




////////////////////////////////////////////////////
//// family
///////////////////////////////////////////////////
static void family(void)
{

  char systemstring[164];

  sprintf(systemstring,"./gedchild %s %s 1 &",indi_check,filename);
  system(systemstring);
}
////////////////////////////////////////////////////
//
///////////////////////////////////////////////////
void parent(void)
{

  char systemtext[60];

  sprintf(systemtext,"./gedtree %s %s &",filename, indi_check);

  system(systemtext);

}

void help(void)
{
 
  x_imgbox("images/helptext.xpm","Help");

}

//////////////////////////////////
// add spouce
////////////////////////////////////////
void add_spouce(void)
{
  char spouce_string[90];
  if(indi_sex[0]=='F')
    sprintf(spouce_string,"./gedadd_spouce %s %s M",indi_check,filename);
  if(indi_sex[0]=='M')
    sprintf(spouce_string,"./gedadd_spouce %s %s F",indi_check,filename);
  system(spouce_string);

  printf("indi sex='%c' and spouce string='%s' \n",indi_sex[0],spouce_string);
}


//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){

  char last_action[15];
  char indi_name[95];
  char indi_titl[95];

  int  indi_name_t;
  int  indi_titl_t;

  char indi_birthdate[90];
  int  indi_birthdate_t;
  char indi_birthplace[90];
  int  indi_birthplace_t;

  char indi_deathdate[90];
  int  indi_deathdate_t;
  char indi_deathplace[90];
  int  indi_deathplace_t;

  char indi_addr[100];
  int  indi_addr_t;
  char indi_educ[100];
  int  indi_educ_t;
  char indi_occu[100];
  int  indi_occu_t;
  char indi_reli[100];
  int  indi_reli_t;

  char input1[95], input2[95];
  //int individual;
  int button_01, button_02, button_03, button_04, button_05;
  int label0,label1,label2,label3,label4,label5,label6;
  int label7,label8,label9,label10;
  int flag1=0;
  int x=0;
  int line=5;
  int indi_found=0;

  int loopy=0;

  FILE *fp5;

  strcpy(filename, argv[1]);
  strcpy(indi_birthplace," ");
  strcpy(indi_deathplace," ");
  strcpy(indi_deathdate," ");
  strcpy(indi_addr," "); 
  strcpy(indi_educ," ");
  strcpy(indi_occu," ");
  strcpy(indi_reli," ");
  fp5=fopen(argv[1],"r+");

  x_open();

  /* create a new window */
  gdx_window("GEDCOM Individual",500,400);
  gdx_setwindowbg("images/bg.xpm",1);


  gdx_frame(35,18,490,360,"Individual data for GEDCOM ID:");

  button_01 = gdx_imagebutton(5,25,"images/close.xpm",destroy);
  button_02 = gdx_imagebutton(5,50,"images/pari.xpm",parent);
  button_03 = gdx_imagebutton(5,75,"images/chil.xpm",family);
  button_04 = gdx_imagebutton(5,100,"images/marr.xpm",add_spouce);
  button_05 = gdx_imagebutton(5,150,"images/help.xpm",help);

  label0 = gdx_label(argv[2],222,15,1);
  gdx_setlabelbg("images/white.xpm",1,label0);

  printf("%s %s %s\n",argv[0],argv[1],argv[2]);

  do{

    loopy++;

    //check for level 0

    fgets(input1,80,fp5);

    if (input1[0]=='0'){ //OK, we have a level 0
      //check for an individual
      //01234567890123
      //0 @I0001@ INDI

      if(input1[2]=='@' && input1[3]=='I' && input1[10]=='I' && input1[11]=='N'){
        indi_found=1;
      }

      if(indi_found==1){
        //Great!, the level 0 is an individual

        for(x=5;x<80;x++) if(input1[x]=='@' ||input1[x]=='I') input1[x]=' ';
        sprintf(indi_check,"%c%c%c%c",input1[4],input1[5],input1[6],input1[7]);

        //check to see if it is the idividual we are looking for 
        //printf("check '%s' = '%s'\n",indi_check,argv[2]);
        if(atoi(indi_check)==atoi(argv[2])){
          //hot grits! it is the idividual we were looking for
          //now read in the individual's information
          do{

            fgets(input1,80,fp5);

            if(input1[0]=='1' && input1[2]=='N' && input1[3]=='A'){     ///1 NAME
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];}
              strcpy(indi_name,input1);
            }



            if(input1[0]=='1' && input1[2]=='T' && input1[3]=='I'){     ///1 TITL
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];}
              strcpy(indi_titl,input1);
            }




             if(input1[0]=='1' && input1[2]=='S' && input1[3]=='E'){ //1 SEX
              indi_sex[0]=input1[6];
              indi_sex[1]='\0';
            }
// last actions

            if(input1[0]=='1' && input1[2]=='C' && input1[3]=='H' && input1[4] =='A'){ //1 CHAN
               strcpy(last_action,"CHAN");
            }

            if(input1[0]=='1' && input1[2]=='B' && input1[3]=='U' && input1[4] =='R'){ //1 BURI
              strcpy(last_action,"BURI");
            }

            if(input1[0]=='1' && input1[2]=='C' && input1[3]=='R' && input1[4] =='E'){ //1 CREM
              strcpy(last_action,"CREM");
            }

            if(input1[0]=='1' && input1[2]=='B' && input1[3]=='I'){ //1 BIRT
               strcpy(last_action,"BIRT");
            }

            if(input1[0]=='1' && input1[2]=='D' && input1[3]=='E' && input1[4] =='A'){ //1 DEAT
              strcpy(last_action,"DEAT");
            }

// Birth Date and Death Date

           if(input1[0]=='2' && input1[2]=='D' && input1[3]=='A'){ //2 DATE
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];
              }
              if(last_action[0]=='B' && last_action[1]=='I'){
                strcpy(indi_birthdate,input1);
              }
              if(last_action[0]=='D' && last_action[1]=='E'){
                strcpy(indi_deathdate,input1);
              }
           }

// Brith Place and Death Place
 
           if(input1[0]=='2' && input1[2]=='P' && input1[3]=='L'){ //2 PLAC
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];
              }
              if(last_action[0]=='B' && last_action[1]=='I'){
                strcpy(indi_birthplace,input1);
              }
              if(last_action[0]=='D' && last_action[1]=='E'){
                strcpy(indi_deathplace,input1);
              }
           }

/// Address
            if(input1[0]=='1' && input1[2]=='A' && input1[3]=='D'){    
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];}
              strcpy(indi_addr,input1);
            }

// Occupation
            if(input1[0]=='1' && input1[2]=='O' && input1[3]=='C'){   
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];}
              strcpy(indi_occu,input1);
            }

// Education
            if(input1[0]=='1' && input1[2]=='E' && input1[3]=='D'){    
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];}
              strcpy(indi_educ,input1);
            }

// Religon
           if(input1[0]=='1' && input1[2]=='R' && input1[3]=='E'){   
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];}
              strcpy(indi_reli,input1);
           }


          //stop when I get to the next idividual

          }while(input1[0] != '0' );

          flag1=22;
        }
      }//if indi

    }//if 0 level

    if(input1[0]=='\0'){

      flag1=22;
      gdx_label("File read error!",50,50,1);
      printf("NULL found!");
    }
   
  }while(flag1!=22);

  //display
  //Name
  label1 = gdx_label("Name:",40,35,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);
  indi_name_t=gdx_textentry(125,25,250,0);
  gdx_settextentry(indi_name_t,indi_name);

  label1 = gdx_label("Title:",40,60,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);
  indi_titl_t=gdx_textentry(125,50,200,0);
  gdx_settextentry(indi_titl_t,indi_titl);

  //Sex
  label2=gdx_label("Sex:",40,85,0);
  gdx_setlabelbg("images/bg.xpm",1,label2);
  indi_sex_t=gdx_textentry(125,75,20,0);
  gdx_settextentry(indi_sex_t,indi_sex);

  //Birth Date
  label3=gdx_label("Birth Date:",40,110,0);
  gdx_setlabelbg("images/bg.xpm",1,label3);
  indi_birthdate_t=gdx_textentry(125,100,100,0);
  gdx_settextentry(indi_birthdate_t,indi_birthdate);

  //Birth Place
  label4=gdx_label("Birth Place:",40,135,0);
  gdx_setlabelbg("images/bg.xpm",1,label4);
  indi_birthplace_t=gdx_textentry(125,125,350,0);
  gdx_settextentry(indi_birthplace_t,indi_birthplace);


  //Death Date
  label5=gdx_label("Death Date:",40,160,0);
  gdx_setlabelbg("images/bg.xpm",1,label5);
  indi_deathdate_t=gdx_textentry(125,150,100,0);
  gdx_settextentry(indi_deathdate_t,indi_deathdate);


  label6=gdx_label("Death Place:",40,185,0);
  gdx_setlabelbg("images/bg.xpm",1,label6);
  indi_deathplace_t=gdx_textentry(125,175,350,0);
  gdx_settextentry(indi_deathplace_t,indi_deathplace);

  label7 = gdx_label("Address:",40,235,0);
  gdx_setlabelbg("images/bg.xpm",1,label7);
  indi_addr_t=gdx_textentry(125,225,350,0);
  gdx_settextentry(indi_addr_t,indi_addr);

  label8 = gdx_label("Occupation:",40,260,0);
  gdx_setlabelbg("images/bg.xpm",1,label8);
  indi_occu_t=gdx_textentry(125,250,350,0);
  gdx_settextentry(indi_occu_t,indi_occu);

  label9 = gdx_label("Education:",40,285,0);
  gdx_setlabelbg("images/bg.xpm",1,label9);
  indi_educ_t=gdx_textentry(125,275,350,0);
  gdx_settextentry(indi_educ_t,indi_educ);

  label10 = gdx_label("Religon:",40,310,0);
  gdx_setlabelbg("images/bg.xpm",1,label10);
  indi_reli_t=gdx_textentry(125,300,350,0);
  gdx_settextentry(indi_reli_t,indi_reli);

  gdx_main();
  x_close();

  return(0);
}

